import gzip
from topLevelDomains import top_level_domains, top_level_domains_countries

counter_index = 0
last_epoch_index = 1
frequency_index = 2

null_frequency = 4294967295

def split(request):
	tokens = request.split('.')
	if tokens[-1] in top_level_countries:
		if tokens[-2] in top_level_countries_aux:
			domain_size = 3
		else:
			domain_size = 2
	else:
		domain_size = 2
	return '.'.join(tokens[:-domain_size]), '.'.join(tokens[-domain_size:])

def count(fields_dict, domain, curr_epoch):
	if domain in fields_dict:
		epoch_diff, frequency = curr_epoch - fields_dict[domain][last_epoch_index], fields_dict[domain][frequency_index]
		fields_dict[domain][counter_index] += 1
		fields_dict[domain][last_epoch_index] = curr_epoch
		fields_dict[domain][frequency_index] = epoch_diff if frequency == null_frequency else (frequency + epoch_diff)/2
	else:
		fields_dict[domain] = [1, curr_epoch, null_frequency]
	return fields_dict[domain][counter_index], fields_dict[domain][frequency_index]

def entropy(array):
	if len(array) > 0:
		return len(gzip.compress(array))/len(array)
	else:
		return 0

# returns counter, frequency, length, entropy
def create_fields(fields_dict, request, curr_epoch):
	subdomain, domain = split(request)
	counter, frequency = count(fields_dict, domain, curr_epoch)
	return counter, frequency, len(subdomain), entropy(subdomain.encode('ascii'))